local hitmarkers = {}

function draw()
	for k,_ in pairs( hitmarkers ) do
		love.graphics.setColor( 255, 255, 255, k.alpha )
		love.graphics.draw( Image.hitmarker, k.x, k.y, 0, 2, 2, 12, 12 )
	end
end

function new( x, y, dly )
	local k = { x=x, y=y, alpha=0 }
	Sound.hitmarker:play()
	flux.to( k, 0.01, {alpha=255} ):delay( dly or 0 ):oncomplete( function () Sound.hitmarker:play() end )
		:after( 0.5, {alpha=0} ):oncomplete( function () hitmarkers[k] = nil end )
	hitmarkers[k] = k
end

function many( x, y )
	local k = {}
	for i=1,10 do
		k[i] = { x=x+math.random(-70,70), y=y+math.random(-15,15), alpha=0 }
		Sound.hitmarker:play()
		flux.to( k[i], 0.01, {alpha=255} ):oncomplete( function () Sound.hitmarker:play() end ):delay( i*0.05 )
			:after( 0.5, {alpha=0} ):oncomplete( function () hitmarkers[k[i]] = nil end )
		hitmarkers[k[i]] = k[i]
	end
end

return { draw=draw, new=new, many=many }