local shaders = {
	rainbow = love.graphics.newShader(
		[[
			extern number time;
			varying vec4 vpos;
			
			vec4 hsv2rgb(vec4 c)
			{
				vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
				//vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
				//vec3 p = abs(fract(c.xxx + K.xyz) * 4.0 - K.www);
				vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
				return vec4( c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y ), c.a );
			}
			
			vec4 effect( vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords )
			{
				color = hsv2rgb( vec4( floor(vpos.x/20000*200)/200 + floor(vpos.y/1600*20)/20 + mod( time / 3, 1.0 ), 0.7, 0.7, 1.0 ) );
				return  color;
			}
		]],
		[[
			varying vec4 vpos;
			
			vec4 position( mat4 transform_projection, vec4 vertex_position )
			{
				vpos = vertex_position;
				return transform_projection * vertex_position;
			}
		]]
	),
	blur = love.graphics.newShader(
		[[
			vec4 effect ( vec4 color, Image tex, vec2 tc, vec2 pc ) {
				vec2 offset = vec2(1.0)/love_ScreenSize.xy;
				color = Texel(tex, tc);
				number intensity = 5.1;

				color += Texel(tex, tc + intensity*vec2(-offset.x, offset.y));
				color += Texel(tex, tc + intensity*vec2(0.0, offset.y));
				color += Texel(tex, tc + intensity*vec2(offset.x, offset.y));

				color += Texel(tex, tc + intensity*vec2(-offset.x, 0.0));
				color += Texel(tex, tc + intensity*vec2(0.0, 0.0));
				color += Texel(tex, tc + intensity*vec2(offset.x, 0.0));

				color += Texel(tex, tc + intensity*vec2(-offset.x, -offset.y));
				color += Texel(tex, tc + intensity*vec2(0.0, -offset.y));
				color += Texel(tex, tc + intensity*vec2(offset.x, -offset.y));

				return color/9.0;
			}
		]],
		[[
			vec4 position( mat4 transform_projection, vec4 vertex_position )
			{
				return transform_projection * vertex_position;
			}
		]]
	),
	mask = love.graphics.newShader(
		[[
			vec4 effect ( vec4 color, Image mask, vec2 tc, vec2 pc ) {
				if ( Texel( mask, tc ).rgb == vec3(0.0f) )
					discard;
				return vec4( 1.0f );
			}
		]],
		[[
			vec4 position( mat4 transform_projection, vec4 vertex_position )
			{
				return transform_projection * vertex_position;
			}
		]]
	),	
}

return shaders