util			= require"lib.util"
shaders			= require"lib.shaders"
flux			= require"lib.flux"
Gamestate		= require"lib.gamestate"
debugDraw		= require"debugdraw"

math.randomseed( os.time() )
each( {1,2,3,4,5,6,7,8,9,10}, math.random )
	
function love.load()
	if arg[#arg] == "-debug" then (require"mobdebug").start() end
	
	world = love.physics.newWorld( 0, 250, true )
	
    Gamestate.registerEvents()
	
	Gamestate.switch( State.volleyball )
	flux.to({x=1},0.2,{x=2}):oncomplete( function () Gamestate.push( State.menu ) end )
	
	lastState = love.graphics.newCanvas()
	
	local font = love.graphics.getFont()
	font:setFilter( "nearest", "nearest" )
	
	music = love.audio.newSource( "assets/audio/Skip-HyperSpaceAdventure.mp3", "stream" )
	music:setLooping( true )
	music:setVolume( 0.8 )
	music:play()
end

function love.update( dt )
	flux.update( dt )
end

function love.keypressed( key )
	if key == "escape" then
		if Gamestate.current() ~= State.menu then
			Gamestate.push( State.menu )
		else
			love.event.push( "quit" )
		end
	elseif key == "f" then
		love.window.setFullscreen( not love.window.getFullscreen() )
	elseif key == "m" then
		music:setVolume( music:getVolume() == 0 and 0.8 or 0 )
	end
end